package com.zcloud.service.courseware;

import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;

import java.util.List;

/**
 * 说明：习题管理
 * 作者：luoxiaobao
 * 时间：2021-07-03
 * 官网：www.zcloudchina.com
 */
public interface QuestionService{

	/**新增
	 * @param pd
	 * @throws Exception
	 */
	public void save(PageData pd)throws Exception;

	/**删除
	 * @param pd
	 * @throws Exception
	 */
	public void delete(PageData pd)throws Exception;

	/**修改
	 * @param pd
	 * @throws Exception
	 */
	public void edit(PageData pd)throws Exception;

	/**列表
	 * @param page
	 * @throws Exception
	 */
	public List<PageData> list(Page page)throws Exception;

	/**列表(全部)
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> listAll(PageData pd)throws Exception;

	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	public PageData findById(PageData pd)throws Exception;

	/**批量删除
	 * @param pd
	 * @throws Exception
	 */
	public void deleteAll(PageData pd)throws Exception;

	/**列表(根据所选ID获取数据)
	 * @param pd
	 * @throws Exception
	 */
	List<PageData> findByIds(PageData pd)throws Exception;

	/**批量删除(根据所选课件ids删除习题)
	 * @param pd
	 * @throws Exception
	 */
	void deleteByCoursewareIds(PageData pd) throws Exception;

	/**列表(根据课程所选课件获取习题数据)
	 * @param pd
	 * @throws Exception
	 */
    List<PageData> listByCourseware(PageData pd) throws Exception;

	/**列表(按照试卷试题数随机抽取课程习题)
	 * @param pd CURRICULUMID	课件ID
	 * @throws Exception
	 */
	List<PageData> listByQuestionNum(PageData pd) throws Exception;

	/**列表(按照试卷试题数及课件范围随机抽取课程习题)
	 * @param pd CURRICULUMID	课件ID
	 * @throws Exception
	 */
	List<PageData> findForStageByQuestionNum(PageData pd);

	/**列表(根据课程所选课件获取习题数据)
	 * @param pd CURRICULUMID	课件ID
	 * @throws Exception
	 */
	public PageData countByCourseware(PageData pd) throws Exception;

	/**列表(根据阶段考试所选课件范围获取习题数据)
	 * @param pd COURSEWARES	课件ID+课件分类
	 * @throws Exception
	 */
    PageData countByStageExamCourseware(PageData pd) throws Exception;

	/**列表(全部) 根据类型获取习题数据  -- 准备随机选题
	 * @param pd
	 * @throws Exception
	 */
	List<PageData> listAllByType(PageData pd)throws Exception;

	public Integer hasQuestionNumber (PageData pd) throws Exception;

	/**
	 * 获取最大题号，导入时候使用
	 * @param pd
	 * @return
	 * @throws Exception
	 */
	public Integer maxQuestionNumber (PageData pd) throws Exception;

	/**
	 *
	 * @param pd
	 * @return
	 * @throws Exception
	 */
	public List<PageData> getCountByQuestionType(PageData pd) throws Exception;

    List<PageData> getQuestionList(PageData request) throws Exception;

	PageData getStage(PageData x);
}

